<script>
    // Dependencies
    import { scaleLinear } from "d3-scale";

    // Properties
    export let data;
    export let scale;

    // Size and margins
    const width = 600;
    const height = 250;
    const margin = { top: 10, right: 10, bottom: 10, left: 10 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;
  
    // Variables - names of buildings, date, time
    const unique = [...new Set(data.map(item => item.buildingtype))];
    const time = 24;
    const days = 31;

    // Get data by building
    let mapBuildings = {};
    function addValueToKey(key, value) {
        mapBuildings[key] = mapBuildings[key] || [];
        mapBuildings[key].push(value);
    }

    let it = unique.length * time * days;
    for (let i = 0; i < it; i++) {
        addValueToKey(data[i].buildingtype, data[i].total_heating_energy);
    }

    // Get domains
    let domains = [];
    let maxDomain = [];
    for (let i = 0; i < unique.length; i ++) {
        let minim = Math.min(... mapBuildings[unique[i]]);
        let maxim = Math.max(... mapBuildings[unique[i]]);
        let minmax = [minim, maxim];
        domains.push(minmax);
        maxDomain.push.apply(maxDomain, [minim, maxim]);
    }
    let generalDomain = [Math.min(... maxDomain), Math.max(... maxDomain)];
    domains.push(generalDomain);


    // Scales X and Y
    const xScale = scaleLinear().domain([0, 743]).range([0, innerWidth]);
    function get_yScale (v, ind) {
        let dom;
        if(scale == "per Line") {
            // per line
            dom = domains[ind];
        } else {
            // across lines
            dom = domains[16];
        }
        let yScale = scaleLinear().domain(dom).range([0, 8]);
        return yScale(-v);
    }

    // Colours
    const col = ['#e6194B', '#3cb44b', '#ffe119', '#4363d8', '#f58231',
                '#911eb4', '#42d4f4', '#f032e6', '#bfef45', '#fabed4',
                '#469990', '#dcbeff', '#9A6324', '#fffac8', '#800000',
                '#aaffc3', '#808000', '#ffd8b1', '#000075', '#a9a9a9',
                '#ffffff', '#000000'];
</script>
  
  <svg {width} {height}>
    <g transform="translate({margin.left}, {margin.top})">
        <!--  -->
        {#each unique as building, indB}
            <g transform="translate(0, {0 + (15 * indB)})">
                <!-- Create basic lines -->
                <line x1={xScale(0)} y1={0} x2={xScale(743)} y2={0} stroke="black" stroke-width="0.25"/>
                {#each Object.values(mapBuildings[building]) as val, indV}
                    <!-- Thickness -->
                    <line x1={xScale(indV)} y1={0} x2={xScale(indV)} y2={get_yScale(val, indB)} stroke={col[indB]} stroke-width = "0.25"/>
                {/each}    
            </g>
        {/each}
    </g>
  </svg>
  
  <style>
    svg {
      border: 1px solid black;
      border-radius: 5px;
    }
  </style>
  